BUKU(1)

NAME
buku - Powerful command-line bookmark manager. Your mini web!

SYNOPSIS
buku [OPTIONS] [KEYWORD [KEYWORD ...]]

DESCRIPTION
buku is a command-line utility to store, tag, search and organize bookmarks.

Features

  * Lightweight, clean interface
  * Text editor integration
  * Fetch page title, add tags and comments
  * Multiple search modes (e.g. deep, regex)
  * Continuous search at prompt, on the fly mode switch
  * Open bookmarks and search results in browser
  * Import/export in HTML (FF, Chrome compatible) or Markdown
  * Shorten and expand URLs
  * Smart tag editing with >>, > or << symbols at prompt
  * Password protection (manual)
  * Portable, merge-able database to sync between systems
  * Multithreaded full DB refresh
  * Shell completion scripts, man page with examples

OPERATIONAL NOTES

1.  The database file is stored in:
      - $XDG_DATA_HOME/buku/bookmarks.db, if XDG_DATA_HOME is defined (first preference) or
      - $HOME/.local/share/buku/bookmarks.db, if HOME is defined (second preference) or
      - %USERPROFILE%kkmarks.db, if you are on Windows or
      - $PWD on both Windows and non-Windows systems.

2.  If the URL contains characters like ';', '&' or brackets they may be interpreted specially by the shell. To avoid it, add the URL within single or double quotes ('/").

3.  URLs are unique in DB. The same URL cannot be added twice.

4.  Bookmarks with immutable titles are listed with '(L)' after the title.

5.  Tags:
      - Comma (',') is the tag delimiter in DB. A tag cannot have comma(s) in it. Tags are filtered (for unique tags) and sorted. Tags are stored in lower case and can be replaced, appended or deleted.
      - Folder names are converted to all-lowercase tags during bookmarks html import.
      - Releases prior to v2.7 support both capital and lower cases in tags. From v2.7 all tags are stored in lowercase. An undocumented option --fixtags is introduced to modify the older tags. It also fixes another issue where the same tag appears multiple times in the tagset of a record. Run buku --fixtags once.
      - Tags can be edited from the prompt very easily using '>>' (append), '>' (overwrite) and '<<' (remove) symbols. The LHS of the operands denotes the indices and ranges of tags to apply (as listed by --tag or key 't' at prompt) and the RHS denotes the actual DB indices and ranges of the bookmarks to apply the change to.

6.  Update operation:
      - If --title, --tag or --comment is passed without argument, clear the corresponding field from DB.
      - If --url is passed (and --title is omitted), update the title from web using the URL.
      - If indices are passed without any other options (--url, --title, --tag, --comment and --immutable), read the URLs from DB and update titles from web. Bookmarks marked immutable are skipped.
      - Can update bookmarks matching a search, when combined with any of the search options and no arguments to update are passed.

7.  Delete operation:
      - When a record is deleted, the last record is moved to the index.
      - Delete doesn't work with range and indices provided together as arguments. It's an intentional decision to avoid extra sorting, in-range checks and to keep the auto-DB compaction functionality intact. On the same lines, indices are deleted in descending order.
      - Can delete bookmarks matching a search, when combined with any of the search options and no arguments to delete are passed.

8.  Search works in mysterious ways:
      - Case-insensitive.
      - Matches words in URL, title and tags.
      - --sany : match any of the keywords in URL, title or tags. Default search option.
      - --sall : match all the keywords in URL, title or tags.
      - --deep : match substrings (`match` matches `rematched`) in URL, title and tags.
      - --sreg : match a regular expression (ignores --deep).
      - --stag : search bookmarks by a tag, or list all tags alphabetically with usage count (if no arguments).
      - Search results are indexed serially. This index is different from actual database index of a bookmark record which is shown within '[]' after the title.

9.  Encryption is optional and manual. AES256 algorithm is used. To use encryption, the database file should be unlocked (-k) before using buku and locked (-l) afterwards. Between these 2 operations, the database file lies unencrypted on the disk, and NOT in memory. Also, note that the database file is unencrypted on creation.

10. Editor support:
      - A single bookmark can be edited before adding. The editor can be set using the environment variable *EDITOR* or by explicitly specifying the editor. The latter takes precedence. If -a is used along with -w, the details are populated in the editor template.
      - In case of edit and update (a single bookmark), the existing record details are fetched from DB and populated in the editor template. The environment variable EDITOR must be set. Note that -u works independently of -w.
      - All lines beginning with "#" will be stripped. Then line 1 will be treated as the URL, line 2 will be the title, line 3 will be comma separated tags, and the rest of the lines will be parsed as descriptions.

11. Proxy support: please refer to the ENVIRONMENT section.

GENERAL OPTIONS

-a --add URL [tag, ...]
    Bookmark URL along with comma-separated tags. A tag can have multiple words.

-u --update [...]
    Update fields of the bookmarks at specified indices in DB. If no arguments are specified, all titles are refreshed from the web. Works with update modifiers for the fields url, title, tag and comment. If only indices are passed without any edit options, titles are fetched and updated (if not empty). Accepts hyphenated ranges and space-separated indices. Updates search results when used with search options, if no arguments.

-w --write [editor|index]
    Edit a bookmark in editor before adding it. To edit and update an existing bookmark, the index should be passed. However, in this case the environment variable EDITOR must be set.

-d --delete [...]
    Delete bookmarks. Accepts space-separated list of indices (e.g. 5 6 23 4 110 45) or a single hyphenated range (e.g. 100-200). Note that range and list don't work together. Deletes search results when combined with search options, if no arguments.

-v --version
    Show program version and exit.

-h --help
    Show program help and exit.

EDIT OPTIONS

--url [...]
    Specify the URL, works with --update only. Fetches and updates title if --title is not used.

--tag [+|-] [...]
    Specify comma separated tags, works with --add, --update. Clears the tags, if no arguments passed. Appends or deletes tags, if list of tags is preceded by '+' or '-' respectively.

--title [...]
    Manually specify the title, works with --add, --update. Omits or clears the title, if no arguments passed.

-c --comment [...]
    Add notes or description of the bookmark, works with --add, --update. Clears the comment, if no arguments passed.

--immutable N
    Set the title of a bookmark immutable during updates. Works with --add, --update. N=1 sets the immutable flag, N=0 removes it. If omitted, bookmarks are added with N=0.

SEARCH OPTIONS

-s --sany keyword [...]
    Search bookmarks with ANY of the keyword(s) in URL, title or tags and show the results. Prompts to enter result number to open in browser. Note that the sequential result index is not the DB index. The DB index is shown within '[]' after the title.
    This is the default search option for positional arguments if no other search option is specified.

-S --sall keyword [...]
    Search bookmarks with ALL keywords in URL, title or tags and show the results. Behaviour same as --sany.
    Special keywords:
    "blank": list entries with empty title/tag
    "immutable": list entries with locked title
    NOTE: To search the keywords, use --sany

--deep
    Search modifier to match substrings. Works with --sany, --sall.

-r --sreg expression
    Scan for a regular expression match.

-t --stag [...]
    Search bookmarks by a tag. List all tags alphabetically, if no arguments. The usage count (number of bookmarks having the tag) is shown within first brackets.

ENCRYPTION OPTIONS

-l --lock [N]
    Encrypt (lock) the DB file with N (> 0, default 8) hash passes to generate key.

-k --unlock [N]
    Decrypt (unlock) the DB file with N (> 0, default 8) hash passes to generate key.

POWER OPTIONS

-e --export file
    Export bookmarks to Firefox bookmarks formatted HTML. Works with --tag to export only specific tags. Markdown is used if file has extension '.md'.
    Markdown format: [title](url), 1 entry per line.

-i --import file
    Import bookmarks exported from Firefox or Google Chrome as HTML. file is considered Markdown (compliant with --export format) if it has '.md' extension.

-m --merge file
    Add bookmarks from another buku database file.

-p --print [...]
    Show details (DB index, URL, title, tags and comment) of bookmark record by DB index. If no arguments, all records with actual index from DB are shown. Accepts hyphenated ranges and space-separated indices. A negative value (introduced for convenience) behaves like the tail utility, e.g., -n shows the details of the last n bookmarks.

-f --format N
    Show selective monochrome output with specific fields. Works with --print. Search results honour the option when used along with --json. Useful for creating batch scripts.
    N = 1, show only URL.
    N = 2, show URL and tags in a single line.
    N = 3, show only title.

-j --json
    Output data formatted as json, works with --print output and search results.

--nc
    Disable color output in all messages. Useful on terminals which can't handle ANSI color codes or scripted environments.

--np
    Do not show the prompt, run and exit.

-o --open [...]
    Open bookmarks by DB indices or ranges in browser. Open a random index if argument is omitted.

--oa
    Open all search results immediately in the browser. Works best with --np. When used along with --update or --delete, URLs are opened in the browser first and then modified or deleted.

--replace old new
    Replace old tag with new tag if both are passed; delete old tag if new tag is not specified.

--shorten index|URL
    Shorten the URL at DB index or an independent URL using the tny.im URL shortener service.

--expand index|URL
    Expand the URL at DB index or an independent URL shortened using tny.im.

--tacit
    Show lesser output. Reduces the verbosity of certain operations like add, update etc.

--threads
    Maximum number of parallel network connection threads to use during full DB refresh. By default 4 connections are spawned. N can range from 1 to 10.

-V  Check the latest upstream version available. This is FYI. It is possible the latest upstream released version is still not available in your package manager as the process takes a while.

-z --debug
    Show debug information and additional logs.

PROMPT KEYS

1-N Browse search results by indices and ranges.

a   Open all search results in browser.

s keyword [...]
    Search for records with ANY keyword.

S keyword [...]
    Search for records with ALL keywords.

d   Toggle deep search to match substrings ('pen' matches 'opened').

r expression
    Run a regular expression search.

t [...]
    Search bookmarks by a tag. List all tags alphabetically, if no arguments. The index of a tag from the tag list can be used to search all bookmarks having the tag. Note that multiple indices and/or ranges do not work in this case.

g [...][>>|>|<<][...]
    Append, remove tags to/from indices and/or ranges.

p [...]
    Print bookmarks by indices and/or ranges.

w [editor|index]
    Edit and add or update a bookmark.

?   Show help on prompt keys.

q, ^D, double Enter
    Exit buku.

ENVIRONMENT

Completion scripts
    Shell completion scripts for Bash, Fish and Zsh can be found in:
    https://github.com/jarun/Buku/blob/master/auto-completion

BROWSER
    Overrides the default browser. Refer to:
    http://docs.python.org/library/webbrowser.html

EDITOR
    If defined, will be used as the editor to edit bookmarks with option --write.

https_proxy
    If defined, will be used to access http and https resources through the configured proxy. Supported format: http[s]://[username:password@]proxyhost:proxyport/

GUI integration
    buku can be integrated in a GUI environment with simple tweaks. Refer to:
    https://github.com/jarun/Buku#gui-integration

EXAMPLES

1.  Edit and add a bookmark from editor:

    buku -w
    buku -w 'macvim -f' -a https://ddg.gg search engine, privacy

    The first command picks editor from the environment variable EDITOR. The second command will open macvim with option -f and the URL and tags populated in template.

2.  Add a bookmark with tags 'search engine' and 'privacy', comment 'Search engine with perks', fetch page title from the web:

    buku -a https://ddg.gg search engine, privacy -c Search engine with perks

    In the output, >: url, +: comment, #: tags.

3.  Add a bookmark with tags 'search engine' & 'privacy' and immutable custom title 'DDG':

    buku -a https://ddg.gg search engine, privacy --title 'DDG' --immutable 1

    Note that URL must precede tags.

4.  Add a bookmark without a title (works for update too):

    buku -a https://ddg.gg search engine, privacy --title

5.  Edit and update a bookmark from editor:

    buku -w 15012014

    This will open the existing bookmark's details in the editor for modifications. Environment variable EDITOR must be set.

6.  Update existing bookmark at index 15012014 with new URL, tags and comments, fetch title from the web:

    buku -u 15012014 --url http://ddg.gg/ --tag web search, utilities -c Private search engine

7.  Fetch and update only title for bookmark at 15012014:

    buku -u 15012014

8.  Update only comment for bookmark at 15012014:

    buku -u 15012014 -c this is a new comment

    Applies to --url, --title and --tag too.

9.  Export bookmarks tagged 'tag 1' or 'tag 2' to HTML and markdown:

    buku -e bookmarks.html --tag tag 1, tag 2
    buku -e bookmarks.md --tag tag 1, tag 2

    All bookmarks are exported if --tag is not specified.

10. Import bookmarks from HTML and markdown:

    buku -i bookmarks.html
    buku -i bookmarks.md

11. Delete only comment for bookmark at 15012014:

    buku -u 15012014 -c

    Applies to --title and --tag too. URL cannot be deleted without deleting the bookmark.

12. Update or refresh full DB with page titles from the web:

    buku -u
    buku -u --tacit (show only failures and exceptions)

    This operation does not modify the indexes, URLs, tags or comments. Only title is refreshed if fetched title is non-empty.

13. Delete bookmark at index 15012014:

    buku -d 15012014

    The last index is moved to the deleted index to keep the DB compact.

14. Delete all bookmarks:

    buku -d

15. Delete a range or list of bookmarks:

    buku -d 100-200
    buku -d 100 15 200

16. Search bookmarks for ANY of the keywords 'kernel' and 'debugging' in URL, title or tags:

    buku kernel debugging
    buku -s kernel debugging

17. Search bookmarks with ALL the keywords 'kernel' and 'debugging' in URL, title or tags:

    buku -S kernel debugging

18. Search bookmarks tagged 'general kernel concepts':

    buku --stag general kernel concepts

19. List all unique tags alphabetically:

    buku --stag

20. Run a search and update the results:

    buku -s kernel debugging -u --tag + linux kernel

21. Run a search and delete the results:

    buku -s kernel debugging -d

22. Encrypt or decrypt DB with custom number of iterations (15) to generate key:

    buku -l 15
    buku -k 15

    The same number of iterations must be specified for one lock & unlock instance. Default is 8, if omitted.

23. Show details of bookmarks at index 15012014 and ranges 20-30, 40-50:

    buku -p 20-30 15012014 40-50

24. Show details of the last 10 bookmarks:

    buku -p -10

25. Show all bookmarks with real index from database:

    buku -p
    buku -p | more

26. Replace tag 'old tag' with 'new tag':

    buku --replace 'old tag' 'new tag'

27. Delete tag 'old tag' from DB:

    buku --replace 'old tag'

28. Append (or delete) tags 'tag 1', 'tag 2' to (or from) existing tags of bookmark at index 15012014:

    buku -u 15012014 --tag + tag 1, tag 2
    buku -u 15012014 --tag - tag 1, tag 2

29. Open URL at index 15012014 in browser:

    buku -o 15012014

30. List bookmarks with no title or tags for bookkeeping:

    buku -S blank

31. List bookmarks with immutable title:

    buku -S immutable

32. Shorten the URL www.google.com and the URL at index 20:

    buku --shorten www.google.com
    buku --shorten 20

33. Append, remove tags at prompt (taglist index to the left, bookmark index to the right):

    // append tags at taglist indices 4 and 6-9 to existing tags in bookmarks at indices 5 and 2-3
    buku (? for help) g 4 9-6 >> 5 3-2
    // set tags at taglist indices 4 and 6-9 as tags in bookmarks at indices 5 and 2-3
    buku (? for help) g 4 9-6 > 5 3-2
    // remove all tags from bookmarks at indices 5 and 2-3
    buku (? for help) g > 5 3-2
    // remove tags at taglist indices 4 and 6-9 from tags in bookmarks at indices 5 and 2-3
    buku (? for help) g 4 9-6 << 5 3-2

AUTHOR
Arun Prakash Jana <engineerarun@gmail.com>.

HOME
https://github.com/jarun/Buku

REPORTING BUGS
https://github.com/jarun/Buku/issues

LICENSE
Copyright © 2015-2017 Arun Prakash Jana <engineerarun@gmail.com>.

License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
This is free software: you are free to change and redistribute it. There is NO WARRANTY, to the extent permitted by law.